/* Includes ------------------------------------------------------------------*/
#include "main.h"
#include "stm32f4xx_hal.h"
#include "fatfs.h"
#include "extern.h"

#include <stdbool.h>

/* USER CODE BEGIN Includes */
#include "sd.h"
/* USER CODE END Includes */


#define NSAMPLES 1000
#define TIMEOUT_FILE_PERIOD 4


	static uint16_t values[NSAMPLES];

// CONSTANTS
	static uint16_t C1; // Pressure sensitivity | SENS T1 
	static uint16_t C2; // Pressure offset | OFF 
	static uint16_t C3; // Temperature coefficient of pressure sensitivity | TCS 
	static uint16_t C4; // Temperature coefficient of pressure offset | TCO 
	static uint16_t C5; // Reference temperature | T REF 
	static uint16_t C6; // Temperature coefficient of the temperature | TEMPSENS 

	static uint16_t PRESSURE_value;

	extern ADC_HandleTypeDef hadc1;
	extern DAC_HandleTypeDef hdac;
	extern DMA_HandleTypeDef hdma_adc1;
	extern TIM_HandleTypeDef htim2;
	extern TIM_HandleTypeDef htim5;

	bool new_pressure_value = 0;

	volatile bool half_flag = 0;
	volatile bool full_flag = 0;
	volatile bool timer_flag = 0;

	volatile bool new_exti = 0;
	volatile uint8_t STATE_OF_EXE = 0;

	volatile uint32_t adc_run = 0;
	//volatile uint32_t pressure_run = 0;
	
	
	//uint8_t timeout_file_counter = 0;
	
	uint16_t counter = 0;
	
	bool half_compl = 0, full_compl = 0;

int main(void)
{
	/*
	SCB_DEMCR |= 0x01000000;
	DWT_CONTROL |= 1;
	DWT_CYCCNT = 0;
	*/
	
	
	init();
	HAL_TIM_Base_Stop_IT(&htim2);
	SD_Check_OpenFile();
	startup_sensor(&C1, &C2, &C3, &C4, &C5, &C6);
	
  /* Infinite loop */
  /* USER CODE BEGIN WHILE */
	
	while (1)
  {
		
		if (half_flag == 1)
		{
			
			if (new_pressure_value == 1)
			{
				
				new_pressure_value = 0;
				HAL_GPIO_TogglePin(GPIOB, GPIO_PIN_1);
				values[0] = PRESSURE_value + 4096;
				
			}
 
			half_flag = 0;
			write_SD(values, NSAMPLES); //(uint16_t*)
			
		}
		
		
		if (full_flag == 1)
		{

			full_flag = 0;
			write_SD(values + NSAMPLES/2, NSAMPLES);
			
		}
		
		
		if (timer_flag == 1)
		{

			//pressure_run++;	
			PRESSURE_value = pres_sensor(C1, C2, C3, C4, C5, C6);
			timer_flag = 0;
			
		}
		
		/*
		if (timeout_file_counter == TIMEOUT_FILE_PERIOD)
		{
			
			timeout_file_counter = 0;
			HAL_GPIO_TogglePin(GPIOC, GPIO_PIN_8);
			
			// stop execution
			HAL_ADC_Stop_DMA (&hadc1);	
			HAL_TIM_Base_Stop_IT(&htim2);	
			// close file
			CloseFile();
			
			
			// open new file
			SD_Check_OpenFile();
			// restart exe
			HAL_TIM_Base_Start_IT(&htim2);
			HAL_ADC_Start_DMA (&hadc1, (uint32_t*)&values, NSAMPLES); 

		}
		*/
		
		if(new_exti)
		{
			
			switch(STATE_OF_EXE)
				{
				
					case 0:
						HAL_GPIO_WritePin(GPIOD, GPIO_PIN_3, GPIO_PIN_SET);
						HAL_GPIO_WritePin(GPIOD, GPIO_PIN_6, GPIO_PIN_RESET); 
						HAL_GPIO_WritePin(GPIOB, GPIO_PIN_1, GPIO_PIN_RESET);
						
						break;
					
					case 1:
						HAL_GPIO_WritePin(GPIOD, GPIO_PIN_3, GPIO_PIN_RESET); 
						HAL_GPIO_WritePin(GPIOD, GPIO_PIN_6, GPIO_PIN_SET); 
						//HAL_GPIO_WritePin(GPIOB, GPIO_PIN_1, GPIO_PIN_RESET);
						
						HAL_TIM_Base_Start_IT(&htim2);
						//HAL_TIM_Base_Stop(&htim6);
						//HAL_TIM_Base_Start(&htim6);	
						HAL_ADC_Start_DMA (&hadc1, (uint32_t*)&values, NSAMPLES); //(uint32_t*)&
					
						break;
					
					case 2:
							
						HAL_GPIO_WritePin(GPIOD, GPIO_PIN_3, GPIO_PIN_SET); 
						HAL_GPIO_WritePin(GPIOD, GPIO_PIN_6, GPIO_PIN_SET); 	
						HAL_GPIO_WritePin(GPIOB, GPIO_PIN_1, GPIO_PIN_SET);		
						
						HAL_TIM_Base_Stop_IT(&htim2);	
						HAL_ADC_Stop_DMA (&hadc1);	
						CloseFile();
						
						break;
					
					case 3:
						
						HAL_PWR_EnterSTANDBYMode();					

						break;
					
					default:
						
						HAL_GPIO_WritePin(GPIOD, GPIO_PIN_3, GPIO_PIN_SET); 
						HAL_GPIO_WritePin(GPIOD, GPIO_PIN_6, GPIO_PIN_SET);
						//HAL_GPIO_WritePin(GPIOB, GPIO_PIN_1, GPIO_PIN_SET);
					
					break;
				}
				
				new_exti = 0;
				STATE_OF_EXE ++;
		
		}
		
	}
	
  /* USER CODE END 3 */
	
					
					// STANDBY DEEP SLEEP
						//HAL_PWR_EnterSTANDBYMode();
					
					// STOP MODE
						//PWR_MAINREGULATOR_ON 
						//PWR_LOWPOWERREGULATOR_ON
						//HAL_PWREx_EnableFlashPowerDown(); // FLASH OFF
						//HAL_PWR_EnterSTOPMode(PWR_LOWPOWERREGULATOR_ON, PWR_SLEEPENTRY_WFI); // Wait For Interrupt 
						
}


/* USER CODE BEGIN 4 */
//----------------------------------------------------------

void HAL_TIM_PeriodElapsedCallback(TIM_HandleTypeDef *htim)
{

	if(htim == &htim2)
	{

			HAL_GPIO_TogglePin(GPIOA, GPIO_PIN_8);
			//timeout_file_counter ++;
			timer_flag = 1;
		
		/*	
			if(pressure_run == NRUN)
			{					
				HAL_TIM_Base_Stop_IT(&htim2);	
				HAL_ADC_Stop_DMA (&hadc1);	
				CloseFile();
				HAL_GPIO_TogglePin(GPIOB, GPIO_PIN_1);
			}
		*/
			
	}

}



void HAL_ADC_ConvHalfCpltCallback(ADC_HandleTypeDef* hadc1)
{
		half_flag = 1;
}


void HAL_ADC_ConvCpltCallback(ADC_HandleTypeDef* hadc1)
{
		full_flag = 1;
}


void HAL_GPIO_EXTI_Callback (uint16_t GPIO_Pin) 
 
{     
 
    if (GPIO_Pin == GPIO_PIN_0)
    {				
			
				// rising edge 
				// se il sensore non fa contatto l'output e 3.3V
				if (HAL_GPIO_ReadPin(GPIOC, GPIO_PIN_0) != 0)
				{
					//STATE_OF_EXE ++;
				}
				
				// falling edge
				// se il sensore fa contatto sull'output 0V
				else 
				{
					//STATE_OF_EXE ++;
					new_exti = 1;
				}
				
				
					
				
		}
 
}



//----------------------------------------------------------
/* USER CODE END 4 */

/**
  * @brief  This function is executed in case of error occurrence.
  * @param  None
  * @retval None
  */
void _Error_Handler(char * file, int line)
{
  /* USER CODE BEGIN Error_Handler_Debug */
  /* User can add his own implementation to report the HAL error return state */
	
	HAL_TIM_Base_Stop_IT(&htim2);	
	HAL_TIM_Base_Stop_IT(&htim5);	
	HAL_ADC_Stop_DMA (&hadc1);	
	CloseFile();
	HAL_GPIO_WritePin(GPIOB, GPIO_PIN_0, GPIO_PIN_SET);
	
	
  while(1) 
  {	
		
  }
  /* USER CODE END Error_Handler_Debug */ 
}

#ifdef USE_FULL_ASSERT

/*
    regs->IFCR = 0x3FU << hdma->StreamIndex;
    regs->IFCR = DMA_FLAG_TCIF0_4 << hdma->StreamIndex; 
		regs->IFCR = DMA_FLAG_HTIF0_4 << hdma->StreamIndex;
*/

		//HAL_GPIO_TogglePin(GPIOA, GPIO_PIN_15);	
			
		
		//__HAL_ADC_CLEAR_FLAG(&hadc1, ~ADC_FLAG_OVR);
		
		//void HAL_NVIC_EnableIRQ (IRQn_Type IRQn);
		
		//HAL_NVIC_EnableIRQ (DMA2_Stream0_IRQn);
		
		//__HAL_ADC_DISABLE_IT(&hadc1, (ADC_IT_EOC | ADC_IT_OVR));
		//hdma_adc1.Instance -> CR  &= ~(DMA_IT_TC | DMA_IT_TE | DMA_IT_DME);
    //hdma_adc1.Instance -> FCR &= ~DMA_IT_FE;
		
		//PRESSURE = pres_sensor(C1, C2, C3, C4, C5, C6); // aggiorno la lettura attuale
		
		//HAL_NVIC_DisableIRQ (DMA2_Stream0_IRQn);
		
		//__HAL_ADC_CLEAR_FLAG(&hadc1, ADC_FLAG_OVR);
		//__HAL_ADC_ENABLE_IT(&hadc1, (ADC_IT_EOC | ADC_IT_OVR));
		//hdma_adc1.Instance -> CR  |= DMA_IT_TC | DMA_IT_TE | DMA_IT_DME;
    //hdma_adc1.Instance -> FCR |= DMA_IT_FE;
		

/**
   * @brief Reports the name of the source file and the source line number
   * where the assert_param error has occurred.
   * @param file: pointer to the source file name
   * @param line: assert_param error line source number
   * @retval None
   */
void assert_failed(uint8_t* file, uint32_t line)
{
  /* USER CODE BEGIN 6 */
  /* User can add his own implementation to report the file name and line number,
    ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  /* USER CODE END 6 */

}

#endif

/**
  * @}
  */ 

/**
  * @}
*/ 

/************************ (C) COPYRIGHT STMicroelectronics *****END OF FILE****/
