/* Includes ------------------------------------------------------------------*/
#include "main.h"
#include "stm32f4xx_hal.h"
#include "fatfs.h"
#include "extern.h"

#include <stdbool.h>

/* USER CODE BEGIN Includes */
#include "sd.h"
/* USER CODE END Includes */

#define NRUN 55 //220

#define NBIT_CODING 6
#define SECONDS_PER_PERIOD 2
#define SECONDS_OF_TX 1


uint16_t buf_one[60] = {
2048, 2262, 2473, 2680, 2880, 3072, 3251, 3418, 3569, 3704, 3821, 3918, 3995, 4051, 
4084, 4094, 4080, 4051, 3995, 3918, 3821, 3704, 3569, 3418, 3251, 3072, 2880, 2680, 
2473, 2262, 2048, 1833, 1622, 1415, 1215, 1024, 844, 677, 526, 391, 274, 177, 100, 
44, 11, 0, 11, 44, 100, 177, 274, 391, 526, 677, 844, 1024, 1215, 1415, 1622, 1833
};

/*
uint16_t buf_zero[60] = {
2048, 2262, 2473, 2680, 2880, 3072, 3251, 3418, 3569, 3704, 3821, 3918, 3995, 4051, 
4084, 4094, 4080, 4051, 3995, 3918, 3821, 3704, 3569, 3418, 3251, 3072, 2880, 2680, 
2473, 2262, 2048, 1833, 1622, 1415, 1215, 1024, 844, 677, 526, 391, 274, 177, 100, 
44, 11, 0, 11, 44, 100, 177, 274, 391, 526, 677, 844, 1024, 1215, 1415, 1622, 1833
};
*/



uint16_t buf_zero[60] = {
2048,2048,2048,2048,2048,2048,2048,2048,2048,2048,
2048,2048,2048,2048,2048,2048,2048,2048,2048,2048,
2048,2048,2048,2048,2048,2048,2048,2048,2048,2048,
2048,2048,2048,2048,2048,2048,2048,2048,2048,2048,
2048,2048,2048,2048,2048,2048,2048,2048,2048,2048,
2048,2048,2048,2048,2048,2048,2048,2048,2048,2048
};




// CONSTANTS
	static uint16_t C1; // Pressure sensitivity | SENS T1 
	static uint16_t C2; // Pressure offset | OFF 
	static uint16_t C3; // Temperature coefficient of pressure sensitivity | TCS 
	static uint16_t C4; // Temperature coefficient of pressure offset | TCO 
	static uint16_t C5; // Reference temperature | T REF 
	static uint16_t C6; // Temperature coefficient of the temperature | TEMPSENS 

	static uint16_t PRESSURE_value;

	

	volatile uint8_t tim4_counter = 0;
	volatile uint32_t min_counter = 0;
	static uint32_t keep_min_counter = 0;

	volatile bool minute_elapsed_flag = 0;
	volatile bool pressure_timer_flag = 0;
	volatile bool tx_of_coding = 0;

	volatile uint32_t pressure_run = 0;
	
	volatile bool new_exti = 0;
	volatile bool run_enable = 0;
	volatile uint8_t STATE_OF_EXE = 0;

	uint8_t bit[NBIT_CODING - 1];
	
	bool new_pressure_value = 0;


	extern TIM_HandleTypeDef htim2, htim4, htim6;
	extern DAC_HandleTypeDef hdac;
	extern DAC_HandleTypeDef hdac, hdac_volume;
	
	static uint32_t volume_12BIT = 4095; // MAX 4095
	
int main(void)
{
	
	int i, j, k;
	
	
	uint32_t period  = SECONDS_OF_TX * 10000;

	uint16_t buf_zero_size = sizeof(buf_zero)/sizeof(uint16_t);
	uint16_t buf_one_size  = sizeof(buf_one)/sizeof(uint16_t);
	
	if (volume_12BIT > 4095)
		volume_12BIT = 4095;	
	
	
	init();
					
	HAL_TIM_Base_Stop(&htim2);				
	HAL_TIM_Base_Stop(&htim4);				
	HAL_TIM_Base_Stop(&htim6);
	
	SD_Check_OpenFile();
	startup_sensor(&C1, &C2, &C3, &C4, &C5, &C6);

/*
	HAL_DAC_Start(&hdac_volume, DAC_CHANNEL_2);
	HAL_DAC_SetValue(&hdac_volume, DAC_CHANNEL_2, DAC_ALIGN_12B_R, volume_12BIT);
*/
	
	
  /* Infinite loop */
  /* USER CODE BEGIN WHILE */
		
	while (1)
	{
		
		for(i = 0; i < buf_one_size; i++)  // sin PA4 10kHz
			{
				//__disable_irq();
				HAL_DAC_SetValue(&hdac, DAC_CHANNEL_1, DAC_ALIGN_12B_R, buf_one[i]);	
				HAL_TIM_Base_Stop(&htim6);
				HAL_TIM_Base_Start(&htim6);					
				//__enable_irq();
			}	

		
		if (minute_elapsed_flag == 1)
			{
			
			tx_of_coding = 1;
				
			keep_min_counter = min_counter;
				
			for(k = 0; k < NBIT_CODING; k++) // encoding of elapsed periods
				bit[k] = (keep_min_counter & ( 1 << k )) >> k;		
				
			// un periodo di stallo
			
			for(k = 0; k < period; k++)
				{
				for(i = 0; i < buf_zero_size; i++)  // silence period
					{	
						HAL_DAC_SetValue(&hdac, DAC_CHANNEL_1, DAC_ALIGN_12B_R, buf_zero[i]);	
						HAL_TIM_Base_Stop(&htim6);
						HAL_TIM_Base_Start(&htim6);
					}
				}
				
				
				
			for(i = NBIT_CODING - 1; i >= 0; i--)
			{
				if(bit[i] == 0)
					{		
						for(k = 0; k < period; k++)
							{
							for(j = 0; j < buf_zero_size; j++)  // silence period
								{	
									HAL_DAC_SetValue(&hdac, DAC_CHANNEL_1, DAC_ALIGN_12B_R, buf_zero[j]);	
									HAL_TIM_Base_Stop(&htim6);
									HAL_TIM_Base_Start(&htim6);
								}
							}							
					}
											
				else if(bit[i] == 1)
					{
					for(k = 0; k < period; k++)
						{						
						for(j = 0; j < buf_one_size; j++)  // sine period
							{	
									HAL_DAC_SetValue(&hdac, DAC_CHANNEL_1, DAC_ALIGN_12B_R, buf_one[j]);	
									HAL_TIM_Base_Stop(&htim6);
									HAL_TIM_Base_Start(&htim6);		
							}	
						}							
					}
			}	
			
									
			for(k = 0; k < period; k++)
				{
				for(i = 0; i < buf_zero_size; i++)  // silence period
					{		
						HAL_DAC_SetValue(&hdac, DAC_CHANNEL_1, DAC_ALIGN_12B_R, buf_zero[i]);	
						HAL_TIM_Base_Stop(&htim6);
						HAL_TIM_Base_Start(&htim6);
					}
				}
						
////////////////////////////////////////////////end coding
				
				
						
				minute_elapsed_flag  = 0;	
				
				tim4_counter = 0;
				
				min_counter = keep_min_counter;
			
				tx_of_coding = 0;
				
			}



			

		
		if (pressure_timer_flag == 1)
		{
			__disable_irq();
			
			pressure_timer_flag = 0;
			PRESSURE_value = pres_sensor(C1, C2, C3, C4, C5, C6);
			
			__enable_irq();
		}
		
		if (new_pressure_value == 1)
		{
			
			__disable_irq();	
			
			new_pressure_value = 0;
			write_SD(&PRESSURE_value, 2);
			
			__enable_irq();
	
		}
			
		
	}
	
	
}


/* USER CODE BEGIN 4 */
//----------------------------------------------------------


void HAL_TIM_PeriodElapsedCallback(TIM_HandleTypeDef *htim)
{

	if(htim == &htim2)
	{
		
		pressure_timer_flag = 1;
	
	}	
	
	if(htim == &htim4)
		{
		
		tim4_counter ++ ;
					
		if(tim4_counter % (SECONDS_PER_PERIOD+1) == 0)
			{
				
				if (tx_of_coding != 1)
					{
					
					minute_elapsed_flag = 1;
					
					tim4_counter = 0; // avoid OVF
					
					min_counter++;
					
					}
			}
			
	}
	
}




//----------------------------------------------------------
/* USER CODE END 4 */

/**
  * @brief  This function is executed in case of error occurrence.
  * @param  None
  * @retval None
  */
void _Error_Handler(char * file, int line)
{
  /* USER CODE BEGIN Error_Handler_Debug */
  /* User can add his own implementation to report the HAL error return state */
	
	HAL_TIM_Base_Stop_IT(&htim2);	
	HAL_TIM_Base_Stop_IT(&htim4);	
	HAL_TIM_Base_Stop_IT(&htim6);	
	HAL_DAC_Stop(&hdac, DAC_CHANNEL_1);
	CloseFile();
	HAL_GPIO_TogglePin(GPIOA, GPIO_PIN_6);
  while(1) 
  {	
		
  }
  /* USER CODE END Error_Handler_Debug */ 
}

#ifdef USE_FULL_ASSERT

/*
    regs->IFCR = 0x3FU << hdma->StreamIndex;
    regs->IFCR = DMA_FLAG_TCIF0_4 << hdma->StreamIndex; 
		regs->IFCR = DMA_FLAG_HTIF0_4 << hdma->StreamIndex;
*/

		//HAL_GPIO_TogglePin(GPIOA, GPIO_PIN_15);	
			
		
		//__HAL_ADC_CLEAR_FLAG(&hadc1, ~ADC_FLAG_OVR);
		
		//void HAL_NVIC_EnableIRQ (IRQn_Type IRQn);
		
		//HAL_NVIC_EnableIRQ (DMA2_Stream0_IRQn);
		
		//__HAL_ADC_DISABLE_IT(&hadc1, (ADC_IT_EOC | ADC_IT_OVR));
		//hdma_adc1.Instance -> CR  &= ~(DMA_IT_TC | DMA_IT_TE | DMA_IT_DME);
    //hdma_adc1.Instance -> FCR &= ~DMA_IT_FE;
		
		//PRESSURE = pres_sensor(C1, C2, C3, C4, C5, C6); // aggiorno la lettura attuale
		
		//HAL_NVIC_DisableIRQ (DMA2_Stream0_IRQn);
		
		//__HAL_ADC_CLEAR_FLAG(&hadc1, ADC_FLAG_OVR);
		//__HAL_ADC_ENABLE_IT(&hadc1, (ADC_IT_EOC | ADC_IT_OVR));
		//hdma_adc1.Instance -> CR  |= DMA_IT_TC | DMA_IT_TE | DMA_IT_DME;
    //hdma_adc1.Instance -> FCR |= DMA_IT_FE;
		

/**
   * @brief Reports the name of the source file and the source line number
   * where the assert_param error has occurred.
   * @param file: pointer to the source file name
   * @param line: assert_param error line source number
   * @retval None
   */
void assert_failed(uint8_t* file, uint32_t line)
{
  /* USER CODE BEGIN 6 */
  /* User can add his own implementation to report the file name and line number,
    ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  /* USER CODE END 6 */

}

#endif

/**
  * @}
  */ 

/**
  * @}
*/ 

/************************ (C) COPYRIGHT STMicroelectronics *****END OF FILE****/

/*		
////////////////////////////////////////////////

					if(bit[6] == 0)
					{		
						for(k = 0; k < period; k++)
							{
								for(j = 0; j < buf_size; j++)  // periodo di stallo
									{	
										HAL_DAC_SetValue(&hdac, DAC_CHANNEL_1, DAC_ALIGN_12B_R, buf_zero[j]);	
										HAL_TIM_Base_Stop(&htim6);
										HAL_TIM_Base_Start(&htim6);						
									}
							}							
					}
							
					else 
					{
						for(k = 0; k < period; k++)
							{						
								for(j = 0; j < buf_size; j++)  // periodo di stallo
									{	
										HAL_DAC_SetValue(&hdac, DAC_CHANNEL_1, DAC_ALIGN_12B_R, buf_one[j]);	
										HAL_TIM_Base_Stop(&htim6);
										HAL_TIM_Base_Start(&htim6);						
									}	
							}							
					}
						
////////////////////////////////////////////////
											
					if(bit[5] == 0)
					{		
						for(k = 0; k < period; k++)
							{
								for(j = 0; j < buf_size; j++)  // periodo di stallo
									{	
										HAL_DAC_SetValue(&hdac, DAC_CHANNEL_1, DAC_ALIGN_12B_R, buf_zero[j]);	
										HAL_TIM_Base_Stop(&htim6);
										HAL_TIM_Base_Start(&htim6);						
									}
							}							
					}
							
					else 
					{
						for(k = 0; k < period; k++)
							{						
								for(j = 0; j < buf_size; j++)  // periodo di stallo
									{	
										HAL_DAC_SetValue(&hdac, DAC_CHANNEL_1, DAC_ALIGN_12B_R, buf_one[j]);	
										HAL_TIM_Base_Stop(&htim6);
										HAL_TIM_Base_Start(&htim6);						
									}	
							}							
					}
						
////////////////////////////////////////////////											
					
					if(bit[4] == 0)
					{		
						for(k = 0; k < period; k++)
							{
								for(j = 0; j < buf_size; j++)  // periodo di stallo
									{	
										HAL_DAC_SetValue(&hdac, DAC_CHANNEL_1, DAC_ALIGN_12B_R, buf_zero[j]);	
										HAL_TIM_Base_Stop(&htim6);
										HAL_TIM_Base_Start(&htim6);						
									}
							}							
					}
							
					else 
					{
						for(k = 0; k < period; k++)
							{						
								for(j = 0; j < buf_size; j++)  // periodo di stallo
									{	
										HAL_DAC_SetValue(&hdac, DAC_CHANNEL_1, DAC_ALIGN_12B_R, buf_one[j]);	
										HAL_TIM_Base_Stop(&htim6);
										HAL_TIM_Base_Start(&htim6);						
									}	
							}							
					}
						
////////////////////////////////////////////////											
					
					if(bit[3] == 0)
					{		
						for(k = 0; k < period; k++)
							{
								for(j = 0; j < buf_size; j++)  // periodo di stallo
									{	
										HAL_DAC_SetValue(&hdac, DAC_CHANNEL_1, DAC_ALIGN_12B_R, buf_zero[j]);	
										HAL_TIM_Base_Stop(&htim6);
										HAL_TIM_Base_Start(&htim6);						
									}
							}							
					}
							
					else 
					{
						for(k = 0; k < period; k++)
							{						
								for(j = 0; j < buf_size; j++)  // periodo di stallo
									{	
										HAL_DAC_SetValue(&hdac, DAC_CHANNEL_1, DAC_ALIGN_12B_R, buf_one[j]);	
										HAL_TIM_Base_Stop(&htim6);
										HAL_TIM_Base_Start(&htim6);						
									}	
							}							
					}
						
////////////////////////////////////////////////											
					
					if(bit[2] == 0)
					{		
						for(k = 0; k < period; k++)
							{
								for(j = 0; j < buf_size; j++)  // periodo di stallo
									{	
										HAL_DAC_SetValue(&hdac, DAC_CHANNEL_1, DAC_ALIGN_12B_R, buf_zero[j]);	
										HAL_TIM_Base_Stop(&htim6);
										HAL_TIM_Base_Start(&htim6);						
									}
							}							
					}
							
					else 
					{
						for(k = 0; k < period; k++)
							{						
								for(j = 0; j < buf_size; j++)  // periodo di stallo
									{	
										HAL_DAC_SetValue(&hdac, DAC_CHANNEL_1, DAC_ALIGN_12B_R, buf_one[j]);	
										HAL_TIM_Base_Stop(&htim6);
										HAL_TIM_Base_Start(&htim6);						
									}	
							}							
					}
						
////////////////////////////////////////////////											
					
					if(bit[1] == 0)		
					{		
						for(k = 0; k < period; k++)
							{
								for(j = 0; j < buf_size; j++)  // periodo di stallo
									{	
										HAL_DAC_SetValue(&hdac, DAC_CHANNEL_1, DAC_ALIGN_12B_R, buf_zero[j]);	
										HAL_TIM_Base_Stop(&htim6);
										HAL_TIM_Base_Start(&htim6);						
									}
							}							
					}
							
					else 
					{
						for(k = 0; k < period; k++)
							{						
								for(j = 0; j < buf_size; j++)  // periodo di stallo
									{	
										HAL_DAC_SetValue(&hdac, DAC_CHANNEL_1, DAC_ALIGN_12B_R, buf_one[j]);	
										HAL_TIM_Base_Stop(&htim6);
										HAL_TIM_Base_Start(&htim6);						
									}	
							}							
					}
						
////////////////////////////////////////////////											
					
					if(bit[0] == 0)
					{		
						for(k = 0; k < period; k++)
							{
								for(j = 0; j < buf_size; j++)  // periodo di stallo
									{	
										HAL_DAC_SetValue(&hdac, DAC_CHANNEL_1, DAC_ALIGN_12B_R, buf_zero[j]);	
										HAL_TIM_Base_Stop(&htim6);
										HAL_TIM_Base_Start(&htim6);						
									}
							}							
					}
							
					else 
					{
						for(k = 0; k < period; k++)
							{						
								for(j = 0; j < buf_size; j++)  // periodo di stallo
									{	
										HAL_DAC_SetValue(&hdac, DAC_CHANNEL_1, DAC_ALIGN_12B_R, buf_one[j]);	
										HAL_TIM_Base_Stop(&htim6);
										HAL_TIM_Base_Start(&htim6);						
									}	
							}							
					}
					
////////////////////////////////////////////////last period of pause
*/
