#include "extern.h"
#include "main.h"
#include "stm32f4xx_hal.h"

extern I2C_HandleTypeDef hi2c1;


void startup_sensor(uint16_t *C1,  uint16_t *C2, uint16_t *C3, uint16_t *C4, uint16_t *C5, uint16_t *C6)
{	
// BUFFERS
	uint8_t tx_buffer[1];
	uint8_t rx_buffer[2] = {0};  //2 bytes for constant
	
/*
// CONSTANTS
	static uint16_t C1; // Pressure sensitivity | SENS T1 
	static uint16_t C2; // Pressure offset | OFF 
	static uint16_t C3; // Temperature coefficient of pressure sensitivity | TCS 
	static uint16_t C4; // Temperature coefficient of pressure offset | TCO 
	static uint16_t C5; // Reference temperature | T REF 
	static uint16_t C6; // Temperature coefficient of the temperature | TEMPSENS 
*/


// RESET 	
	tx_buffer[0] = 0x1E; // RESET CMD
	HAL_I2C_Master_Transmit(&hi2c1, 0xEC, tx_buffer, 1, 1000); //0xEC WRITE MODE; 0xED READ MODE	
		
	
// PROM READ SECTION
	
	//Pressure sensitivity
	tx_buffer[0] = 0xA2; 
	HAL_I2C_Master_Transmit(&hi2c1, 0xEC, tx_buffer, 1, 1000);	
	HAL_I2C_Master_Receive(&hi2c1, 0xED, rx_buffer, 2, 1000); // recives 2 bytes of data position 0 and 1 of the buffer
	*C1 = (rx_buffer[0] << 8)|(rx_buffer[1]);
	
	// Pressure offset
	tx_buffer[0] = 0xA4; 
	HAL_I2C_Master_Transmit(&hi2c1, 0xEC, tx_buffer, 1, 1000);	
	HAL_I2C_Master_Receive(&hi2c1, 0xED, rx_buffer, 2, 1000); // recives 2 bytes of data position 0 and 1 of the buffer
	*C2 = (rx_buffer[0] << 8)|(rx_buffer[1]);

	// Temperature coefficient of pressure sensitivity
	tx_buffer[0] = 0xA6; 
	HAL_I2C_Master_Transmit(&hi2c1, 0xEC, tx_buffer, 1, 1000);	
	HAL_I2C_Master_Receive(&hi2c1, 0xED, rx_buffer, 2, 1000); // recives 2 bytes of data position 0 and 1 of the buffer
	*C3 = (rx_buffer[0] << 8)|(rx_buffer[1]);
	
	// Temperature coefficient of pressure offset
	tx_buffer[0] = 0xA8; 
	HAL_I2C_Master_Transmit(&hi2c1, 0xEC, tx_buffer, 1, 1000);	
	HAL_I2C_Master_Receive(&hi2c1, 0xED, rx_buffer, 2, 1000); // recives 2 bytes of data position 0 and 1 of the buffer
	*C4 = (rx_buffer[0] << 8)|(rx_buffer[1]);
	
	// Reference temperature
	tx_buffer[0] = 0xAA; 
	HAL_I2C_Master_Transmit(&hi2c1, 0xEC, tx_buffer, 1, 1000);	
	HAL_I2C_Master_Receive(&hi2c1, 0xED, rx_buffer, 2, 1000); // recives 2 bytes of data position 0 and 1 of the buffer
	*C5 = (rx_buffer[0] << 8)|(rx_buffer[1]);
	
	// Temperature coefficient of the temperature 
	tx_buffer[0] = 0xAC; 
	HAL_I2C_Master_Transmit(&hi2c1, 0xEC, tx_buffer, 1, 1000);	
	HAL_I2C_Master_Receive(&hi2c1, 0xED, rx_buffer, 2, 1000); // recives 2 bytes of data position 0 and 1 of the buffer
	*C6 = (rx_buffer[0] << 8)|(rx_buffer[1]);

}
