function avg_of_amplitude = exe_avg(file)

[rows, cols] = size(file);

i = 1;
j = 1;
k = 1;

xspace_mult = 10;

linspace_of_samples = linspace(1, rows, xspace_mult*rows);

interped = interp1(linspace(1, rows, rows), file, linspace_of_samples, 'pchip');

% nearest 
% makima 
% pchip 
% spline 
% linear

% figure(1)
% plot(file, ':.')
% hold on
% plot(linspace_of_samples, interped, 'red')
% xlim([10000000 10003000])
% grid on

new_rise = 0;
new_fall = 0;

min = 0;
max = 0;

min_array = zeros(1, xspace_mult*rows+1);
max_array = zeros(1, xspace_mult*rows+1);

for i = 2:xspace_mult*rows
    
    if (interped(i-1) < interped(i))
        
        new_rise = 1;
        max = interped(i);
        if new_fall == 1
            
            min_array(k) = min; %% save local min when slope inversion
            k = k+1; %% update index of mins
            new_fall = 0;
            
        end
        
    end
        
 
    if (interped(i-1) > interped(i))
        
        new_fall = 1;
        min = interped(i);
        if new_rise == 1
            
            max_array(j) = max; %% save local max when slope inversion
            j = j+1; %% update index of max
            new_rise = 0;
            
        end
        
    end
    
end

k = 0;
num_of_max = 0;
num_of_min = 0;

for i = 1:xspace_mult*rows
    
    if ((max_array(i) == 0) && (k == 0))
        
        num_of_max = i;
        k = 1;
        
    end
    
end

temp_max = max_array(1, 1:num_of_max);
temp_min = min_array(1, 1:num_of_max);

% figure(2) 
% plot(temp_max, '.')
% hold on
% title('Graph MAX')
% grid on
% 
% figure(3)
% plot(temp_min, '.')
% hold on
% title('Graph MIN')
% grid on

amplitude_array = zeros(1, num_of_max+1);

for i = 1:num_of_max
    
    amplitude_array(i) = ((max_array(i)) - (min_array(i) + 1))/40.96;
    
end

% figure(4)
% plot (amplitude_array)
% hold on 
% title('Graph Amplitude')
% xlabel('Time [s]')
% ylabel('Amplitude in percentage')
% grid on

i = 0;
k = 1;
j = 0;


avg_period  = 400;

temp_ampl = 0; %zeros(1, avg_period);
avg_of_amplitude = zeros(1, floor(num_of_max/avg_period));

for i = 1:floor(num_of_max/avg_period)
    
    temp_ampl = amplitude_array(1, k:(avg_period-1+k));
    
    k = k + avg_period;

    avg_of_amplitude(i) = mean(temp_ampl);
    
end

end



