clc
clear all
close all

% OPEN FILES
file = importdata('out_adcsamples1.txt');
pressures = importdata('out_senspressures1.txt');

% CALC SIZE
[rows, cols] = size(file);
[press_samples, dump] = size(pressures);

% RUN SCRIPT
avg_of_amplitude = exe_avg(file);

% CALC PARAMS FOR ADC PLOT
[dump, avg_samples] = size(avg_of_amplitude);
time_base = floor(avg_samples/24); % 24 averaged samples corresponds to 1s 
avg_samples = time_base * 24;
avg_of_amplitude(1,1:avg_samples);
xpoints_adc = (0 : 24 : avg_samples) / 24;

% CALC PARAMS FOR PRESSURE SENSOR PLOT
press_step = avg_samples / press_samples;
xpoints_pres = (press_step : press_step : avg_samples);

lowest_press = pressures(1);
highest_press = pressures(1);

for i = 1 : press_samples
    
    if lowest_press > pressures(i)
        
        lowest_press = pressures(i);
        
    end
    
    if highest_press < pressures(i)
        
        highest_press = pressures(i);
        
    end
    
end

low_y_lim = lowest_press - 2 ;
high_y_lim = highest_press + 2;


% BEGIN FIGURE
figure(1)
hold on
grid on

% ADC SAMPLES
yyaxis left

plot(avg_of_amplitude)
xticks (0 : 24 : avg_samples);
xticklabels(xpoints_adc)
xlabel("Time [s]")
ylabel("Signal Strength in percentage [Vin/3.3V]")

% PRESSURE SENSOR 
yyaxis right 

plot(xpoints_pres, pressures, '--gs',...
    'LineWidth', 2, 'MarkerSize', 10, 'MarkerEdgeColor', 'g', 'MarkerFaceColor', [0.5,0.5,0.5])% 'b--o')
ylim([low_y_lim high_y_lim])
ylabel("Pressure [mbar]")



